<?php
$ver = '1.3';

$base_url_host = parse_url(site_url(), PHP_URL_HOST);
unset($settings['customCSS']);

wp_enqueue_style('flagallery-cubik-skin', plugins_url('/css/cubik.css', __FILE__), array('magnific-popup'), $ver);
wp_enqueue_script('flagallery-cubik-skin', plugins_url('/js/cubik.js', __FILE__), array(
    'jquery',
    'magnific-popup',
), $ver, true
);

$div_r     = $settings['thumbRows'] / $settings['thumbCols'];
$all_items = array();
foreach($data as $gallery){
    $path  = $gallery['gallery']['path'];
    $items = $gallery['data'];
    //if($gallery['gallery']['title']){
    //    echo "<h3>{$gallery['gallery']['title']}</h3>";
    //}
    //if($gallery['gallery']['galdesc']){
    //    echo '<div class="flagPhantom_galleryDescription">' . apply_filters('the_content', stripslashes($gallery['gallery']['galdesc'])) . '</div>';
    //}
    foreach($items as $item){

        $meta_data = $item['meta_data'];
        $width     = $meta_data['webview'][0];
        $height    = $meta_data['webview'][1];
        $thumb_r   = $width / $height;
        $ratio     = $thumb_r > $div_r? $thumb_r : $div_r;
        $fn_ext    = explode('.', $item['filename']);
        $attr_data = array(
            'id'    => $item['pid'],
            'ratio' => $ratio,
            'mtype'   => 'image',
            'ext'     => array_pop($fn_ext),
            'views' => $item['hitcounter'],
            'likes' => $item['total_votes'],
        );

        $item['original'] = $path . '/' . $item['filename'];
        $item['image']    = $path . '/webview/' . $item['filename'];
        $item['thumb']    = $path . '/thumbs/thumbs_' . $item['filename'];

        if( !empty($settings['show_download_button'])){
            $attr_data['download'] = $item['original'];
            $attr_data['filename'] = $item['filename'];
        }

        $link_target = '';
        if($item['link']){
            if($settings['link_target']){
                $link_target = $settings['link_target'];
            } else{
                $url_host = parse_url($item['link'], PHP_URL_HOST);
                if($url_host == $base_url_host || empty($url_host)){
                    $link_target = '_self';
                } else{
                    $link_target = '_blank';
                }
            }
            $attr_data['link']   = $item['link'];
            $attr_data['target'] = $link_target;
        }

        if( !empty($settings['thumb2link']) && $item['link']){
            $item['url'] = $item['link'];
        } else{
            $item['url'] = $item['image'];
        }

        $attr_data_html = '';
        foreach($attr_data as $key => $val){
            $attr_data_html .= " data-{$key}='" . esc_attr($val) . "'";
        }
        $item['attr_data_html'] = $attr_data_html;

        ob_start();

        echo '<div class="flagCubik_actions_region flagCubik_section"></div>';

        if((int) $settings['show_title']){
            $title = stripslashes($item['alttext']);
            if($item['link']){
                $title = "<a href='{$item['link']}' target='{$link_target}'>" . ($title? $title : $item['filename']) . '</a>';
            }
        } else{
            $title = '';
        }
        if($title || $item['description']){
            ?>
            <div class="flagCubik_description_region">
                <div class="flagCubik_description">
                    <div class="flagCubik_title"><?php echo $title; ?></div>
                    <div class="flagCubik_text"><?php echo str_replace(array(
                                                                           "\r\n",
                                                                           "\r",
                                                                           "\n",
                                                                       ), '', wpautop(stripslashes($item['description']))
                        ); ?></div>
                </div>
            </div>
            <?php
        }
        ?>
        <div class="flagCubik_details_region">
            <div class="flagCubik_item_details">
                <div class="flagCubik_badges">
                    <div class="flagCubik_badges__column">
                        <div class="flagCubik_badges__label"><?php echo $settings['views_text']; ?></div>
                        <div class="flagCubik_badges__count mfp-views-count"><?php echo $attr_data['views']; ?></div>
                    </div>
                    <div class="flagCubik_badges__column">
                        <div class="flagCubik_badges__label"><?php echo $settings['likes_text']; ?></div>
                        <div class="flagCubik_badges__count mfp-likes-count"><?php echo $attr_data['likes']; ?></div>
                    </div>
                    <div class="flagCubik_clearfix"></div>
                </div>
                <?php
                $exif = $meta_data;
                $details                    = array();
                $details['model']           = empty($exif['camera'])? '' : $exif['camera'];
                $details['camera_settings'] = array(
                    'focallength' => empty($exif['focal_length'])? '' : $exif['focal_length'],
                    'aperture'    => empty($exif['aperture'])? '' : 'ƒ' . str_replace(array('F ', 'F', 'f'), '', $exif['aperture']),
                    'exposure'    => empty($exif['shutter_speed'])? '' : $exif['shutter_speed'],
                    'iso'         => empty($exif['iso'])? '' : 'ISO ' . $exif['iso'],
                );
                $details['camera_settings'] = array_filter($details['camera_settings']);
                $is_details                 = array_filter($details);
                if( !empty($is_details)){
                    ?>
                    <div class="flagCubik_exif flagCubik_section">
                        <div class="flagCubik_label"><?php echo $details['model']; ?></div>
                        <div class="flagCubik_label small flagCubik_camera_settings">
                            <?php echo implode('<span class="flagCubik_sep">/</span>', $details['camera_settings']); ?></div>
                    </div>
                    <?php
                }

                $details = array();
                $details[ __('Taken', 'flash-album-gallery') ]    = empty($exif['created_timestamp'])? '' : date_i18n(get_option('date_format'),strtotime($exif['created_timestamp']));
                $details[ __('Keywords', 'flash-album-gallery') ] = empty($exif['keywords'])? '' : $exif['keywords'];
                $details = array_filter($details);
                if(count($details)){
                    ?>
                    <div class="flagCubik_other_metadata flagCubik_section">
                        <table class="flagCubik_other_metadata_table">
                            <?php foreach($details as $key => $value){ ?>
                                <tr class="flagCubik_metarow_<?php echo sanitize_key($key); ?>">
                                    <td class="flagCubik_metadata_key"><?php echo ucwords($key); ?></td>
                                    <td class="flagCubik_metadata_value"><?php echo $value; ?></td>
                                </tr>
                            <?php } ?>
                        </table>
                    </div>
                    <?php
                } ?>
            </div>
        </div>
        <?php
        $item['details_html'] = ob_get_contents();
        ob_end_clean();

        $all_items[] = $item;
    }
}
?>
    <div class="flagCubik noLightbox">
        <div class="flagCubik_thumbsContainer">
            <div class="flagCubik_thumbsWrapper">
                <?php
                $gridSize = $settings['thumbCols'] * $settings['thumbRows'];
                for($i = 1; $i <= 6; $i ++){
                    echo "<div class='flagCubik_face flagCubik_side-{$i}'><div class='flagCubik_faceContainer'><div class='flagCubik_faceWrapper'>";
                    for($j = 1; $j <= $gridSize; $j ++){
                        $item = array_shift($all_items);
                        if( !$item){
                            break;
                        }
                        ?>
                        <div class="flagCubik_thumb flagCubik_thumbLoader"<?php echo $item['attr_data_html']; ?>>
                            <a class="flagCubik_thumbImg" href="<?php echo $item['url']; ?>" title="<?php esc_attr_e($item['alttext']); ?>"><img src="<?php echo $item['thumb']; ?>" data-src="<?php echo $item['image']; ?>" alt="<?php esc_attr_e($item['alttext']); ?>"></a>
                            <script type="text/html" class="flagCubik_thumbDetails"><?php echo $item['details_html']; ?></script>
                        </div>
                        <?php
                    }
                    echo '</div></div></div>';
                }
                $flagCount = count($all_items);
                if($flagCount){
                    echo '<div class="flagCubik_noplace">';
                    for($i = 0; $i < $flagCount; $i ++){
                        $item = array_shift($all_items);
                        if( !$item){
                            break;
                        }
                        ?>
                        <div class="flagCubik_thumb"<?php echo $item['attr_data_html']; ?>>
                            <a class="flagCubik_thumbImg" href="<?php echo $item['url']; ?>" title="<?php esc_attr_e($item['alttext']); ?>"><img data-src="<?php echo $item['image']; ?>" alt="<?php esc_attr_e($item['alttext']); ?>"></a>
                            <script type="text/html" class="flagCubik_thumbDetails"><?php echo $item['details_html']; ?></script>
                        </div>
                        <?php
                    }
                    echo '</div>';
                }
                ?>
            </div>
        </div>
        <?php
        if(empty($settings['key']) || 'MINIPack' === $settings['name']){
            echo "<a class='flaglove' target='_blank' href='http://bit.ly/2jPNRB0'>" . __('Trial version - Get License', 'flash-album-gallery') . "</a>";
        }
        ?>
    </div>
<?php
/* Dynamic CSS */
$mfp_id  = "#mfp_flag_{$galleryID}";
$mfp_css = '';
if(isset($settings['lightboxControlsColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-arrow-right:after,
{$mfp_id} .mfp-arrow-right .mfp-a {border-left-color:{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-arrow-left:after,
{$mfp_id} .mfp-arrow-left .mfp-a {border-right-color:{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-close,
{$mfp_id} .mfp-likes,
{$mfp_id} .mfp-details,
{$mfp_id} .mfp-share {color:{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-preloader {background-color:{$settings['lightboxControlsColor']};}";
}
if(isset($settings['lightboxTitleColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-title,
{$mfp_id} .mfp-counter {color:{$settings['lightboxTitleColor']};}";
}
if(isset($settings['lightboxTextColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-description {color:{$settings['lightboxTextColor']};}";
}
if(isset($settings['lightboxBGColor'])){
    $mfp_css .= "
{$mfp_id}_bg.mfp-bg {background-color:{$settings['lightboxBGColor']};}";
}
if(isset($settings['lightboxBGAlpha'])){
    $alpha   = $settings['lightboxBGAlpha'] / 100;
    $mfp_css .= "
{$mfp_id}_bg.mfp-bg {opacity:{$alpha};}
{$mfp_id}_bg.mfp-zoom-in.mfp-bg {opacity:0}
{$mfp_id}_bg.mfp-zoom-in.mfp-ready.mfp-bg {opacity:{$alpha};}
{$mfp_id}_bg.mfp-zoom-in.mfp-removing.mfp-bg {opacity:0}";
}
if(isset($settings['sidebarBGColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-details-content {background-color:{$settings['sidebarBGColor']};}";
}
if($mfp_css){
    $settings['mfp_css'] = $mfp_css;
}

$cssid = "#FlaGallery_{$galleryID}";
$dcss  = '';
if(isset($settings['thumbCols'])){
    $width = 100 / $settings['thumbCols'];
    $dcss  .= "
{$cssid} .flagCubik_face .flagCubik_thumb {width:{$width}%;}";
}
if(isset($settings['thumbRows'])){
    $height = 100 / $settings['thumbRows'];
    $dcss   .= "
{$cssid} .flagCubik_face .flagCubik_thumb {height:{$height}%;}";
}
if(isset($settings['thumbsSpacing'])){
    $correction = 0 - $settings['thumbsSpacing'];
    $dcss       .= "
{$cssid} .flagCubik_faceWrapper {left:{$correction}px;top:{$correction}px;}
{$cssid} .flagCubik_thumbImg {left:{$settings['thumbsSpacing']}px;top:{$settings['thumbsSpacing']}px;}";
}
if(isset($settings['faceAlpha']) || isset($settings['faceBG'])){
    if((int) $settings['faceAlpha']){
        $rgb   = implode(',', flagGallery::hex2rgb($settings['faceBG']));
        $alpha = $settings['faceAlpha'] / 100;
        $dcss  .= "
{$cssid} .flagCubik_face {background-color:rgba({$rgb},{$alpha}); border-color:{$settings['faceBG']};}";
    } else{
        $dcss .= "
{$cssid} .flagCubik_face {background-color:transparent; border:none;}";
    }
}
if(isset($settings['facePadding'])){
    $dcss .= "
{$cssid} .flagCubik_face {padding:{$settings['facePadding']}px;}";
}
if(isset($settings['faceMargin'])){
    $neg  = 0 - $settings['faceMargin'];
    $pos  = 0 + $settings['faceMargin'];
    $dcss .= "
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-1 { -webkit-transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); -moz-transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); }
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-2 { -webkit-transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-3 { -webkit-transform:translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:translateX(50%) translateX({$pos}px) rotateY(90deg); transform:translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-4 { -webkit-transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-5 { -webkit-transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); -moz-transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); }
{$cssid} .flagCubik_thumbsWrapper .flagCubik_side-6 { -webkit-transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); -moz-transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); }";
}
if(isset($settings['thumbAlpha']) || isset($settings['thumbAlphaHover'])){
    $alpha  = $settings['thumbAlpha'] / 100;
    $alpha2 = $settings['thumbAlphaHover'] / 100;
    $dcss   .= "
{$cssid} .flagCubik_thumbImg {opacity:{$alpha};}
{$cssid} .flagCubik_thumbImg:hover {opacity:{$alpha2};}";
}
if((int) $settings['bgAlpha'] > 0){
    $rgb   = implode(',', flagGallery::hex2rgb($settings['bgColor']));
    $alpha = $settings['bgAlpha'] / 100;
    $dcss  .= "
{$cssid} .flagCubik {background-color:rgba({$rgb},{$alpha});}";
}
if($dcss){
    $customCSS = $dcss . $customCSS;
}

?>
    <script type="text/javascript">
        jQuery(function(){
            var settings = <?php echo json_encode($settings); ?>;
            jQuery('#FlaGallery_<?php echo $galleryID; ?>').flagCubik([settings]);
        });
    </script><?php
